#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include <unistd.h>
#include <string.h>

#include "gettext.h"
#include "locate_data.h"

int stdin_pipe[2];
int stdout_pipe[2];

int engine_start( char **args )
{
    pipe(stdin_pipe);
    pipe(stdout_pipe);
    
    char *script = locate_data("script");

    pid_t pid = fork();
    if( pid > 0 )
    { // father
	close(stdin_pipe[0]);
//	close(stdin_pipe[1]);
        close(stdout_pipe[1]);
//	close(stdout_pipe[0]);
	return 0;
    }
    else if( pid == 0 )
    { // child
	/* Close the Child process' STDIN */
	close(0);

        /* Duplicate the Child's STDIN to the stdin_pipe file descriptor */
        dup(stdin_pipe[0]);

        /* Close the read and write to for the pipe for the child.  The child will now only be able to read from it's STDIN (which is our pipe). */ 
        close(stdin_pipe[0]);
        close(stdin_pipe[1]);

        /* Close the Child process' STDOUT */
        close(1);
        dup(stdout_pipe[1]);
        close(stdout_pipe[0]);
        close(stdout_pipe[1]);

	char cmd[1024*10];
	int pos = snprintf( cmd, sizeof(cmd), "perl r-anagram.perl --dictionary %s", _("en") );
	for( int i=1 ; args[i]!=NULL ; i++ )
	{
	    int w = snprintf( cmd+pos, sizeof(cmd)-pos, " %s", args[i] );
	    assert( w < (int)sizeof(cmd)-pos ); // all thing is writed
	    pos += w;
	}
	chdir( script );
	system( cmd );
	exit(0);
	return 0;
    }
    else
    {
	return -1;
    }
}

char *engine_read()
{
    #define BUFSIZE 1204*4
    char buffer[BUFSIZE];
    int pos = 0;
    while( pos<BUFSIZE && read( stdout_pipe[0], &buffer[pos], 1 ) && buffer[pos]!='\n' )
    {
	pos++;
    }
    buffer[pos] = 0;
    return strdup(buffer);
}

int engine_write( char *buff )
{
    write( stdin_pipe[1], buff, strlen(buff) );
    return 0;
}
