#include "engine_io.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "engine.h"


char *get_letters_from_engine()
{
    char *read;
    char *letters;
    read = engine_read();
    letters = strchr( read, ' ' );
    if( letters != NULL )
    {
        letters = strdup( letters+1 );
        free( read );
        return letters;
    }
    else
    {
        free( read );
        return NULL;
    }
}

char **get_words_from_engine()
{
    char *read;
    char **words;
    int count, number;
    read =  engine_read();
    char *pos = strchr( read, ' ' );
    if( sscanf( read, "words(%i/%i)", &count, &number ) == 2 && pos != NULL )
    {
        words = (char**) malloc( sizeof(char*) * (number+1) );
        for( int i=0 ; pos!=NULL && i<number ; i++ )
        {
            pos++;
            char buff[1024];
            if( sscanf( pos, "%[^.]s", buff ) != 1 )
            {
                words[i] = NULL;
                pos = NULL;
            }
            else
            {
                words[i] = strdup( buff );
                pos = strchr( pos, '.' );
            }
        }
        words[number] = NULL;
        free( read );
        return words;
    }
    else
    {
        free( read );
        return NULL;
    }
}

void send_answer_to_engine( char *answer )
{
    char buffer[strlen(answer)+2];
    snprintf( buffer, sizeof(buffer), "%s\n", answer );
    engine_write( buffer );
}

char *get_answer_result_from_engine()
{
    char *read;
    char *result;
    read = engine_read();
    result = strchr( read, ' ' );
    if( result != NULL )
    {
        result = strdup( result+1 );
        free( read );
        return result;
    }
    else
    {
        free( read );
        return NULL;
    }
}
