#ifndef letters_word_h
#define letters_word_h

#include <set.h>
#include "sprite_letter.h"
#include "sprite_words.h"
#include "SDL_ttf.h"

class letters_word
{
    public:
	letters_word( char *letters, char **words, set<Sprite*> *sprite_set );
	~letters_word();

	bool move_letter_to_word( char letter, int n );
	bool move_letter_from_word( int n, bool slide=true );
	void shuffle_letters();

	int letters_click( int x, int y );
	int word_click( int x, int y );

	char *get_word() { return word; };
	void set_words( char **words );
	void clear_word();
	void clean_word();

    private:
	char *letters;
	char *word;
	int size;
	set<Sprite*> *sprite_set;
	Sprite_words *sprite_words;

	Sprite_letter **sprite_letters;
	Sprite_letter **sprite_word;

	TTF_Font *font_letter, *font_words;
};

#endif
