#ifndef sprite_h
#define  sprite_h

#include "SDL.h"

#ifdef AUDIO_SDL
#include "SDL_mixer.h"
#endif

class Sprite
{
    public:
	Sprite( Uint16 x, Uint16 y, char *file_sprite, char *file_sprite_hover=NULL, char *file_sprite_click=NULL, const char *file_sound=NULL );
	virtual ~Sprite();

	bool clear( SDL_Rect *splash );
	bool redraw( SDL_Rect *splash );
	void blit();

	void hover( Uint16 x, Uint16 y );
	bool click( Uint16 x, Uint16 y );
	void run();

	SDL_Surface *getSurface() { return sprite; }
	
	void moveTo( Uint16 x, Uint16 y );
	void slideTo( Uint16 x, Uint16 y );

	static SDL_Surface *screen;

    protected:
	bool need_redraw;
	SDL_Surface *sprite, *sprite_hover, *sprite_click;
	SDL_Rect rect, old_rect;
	Uint16 dest_x, dest_y;

	#ifdef AUDIO_SDL
	Mix_Chunk *sound;
	#endif	

	int hover_time, run_time;
	enum {state_null,state_free,state_hover,state_run} state;
    
	Sprite() {};
	void init( Uint16 x, Uint16 y );
	bool is_hover( Uint16 x, Uint16 y );
};

#endif
