#include "sprite_letter.h"

#include <ctype.h>


Sprite_letter::Sprite_letter( Uint16 x, Uint16 y, char letter, TTF_Font *font, char *file_sprite, char *file_sprite_hover, char *file_sprite_click ) :
Sprite( x, y , file_sprite, file_sprite_hover, file_sprite_click )
{
    SDL_Color black  = {  0,  0,  0,0};
    SDL_Color white  = {255,255,255,0};
    SDL_Color yellow = {255,255,  0,0};
    put_letter_on_surface( letter, font, black,  sprite );
    if( sprite_hover == NULL ) sprite_hover = SDL_DisplayFormat( sprite );
    put_letter_on_surface( letter, font, white,  sprite_hover );
    if( sprite_click == NULL ) sprite_click = SDL_DisplayFormat( sprite );
    put_letter_on_surface( letter, font, yellow, sprite_click );
}

void Sprite_letter::put_letter_on_surface( char l, TTF_Font *font, SDL_Color color, SDL_Surface *surface )
{
    char str[] = { toupper(l), 0 };
//    SDL_Surface *letter_surface = TTF_RenderUTF8_Solid( font, str, color );
    SDL_Surface *letter_surface = TTF_RenderText_Blended( font, str, color );
    blit_center( letter_surface, surface );
    SDL_FreeSurface( letter_surface );
}

SDL_Surface *Sprite_letter::blit_center( SDL_Surface *src, SDL_Surface *dest )
{
    SDL_Rect rect = { (dest->w-src->w)/2, (dest->h-src->h)/2, src->w, src->h };
    SDL_BlitSurface( src, NULL, dest, &rect );
    return dest;
}
