#include "sprite_words.h"

#include <stdlib.h>
#include <string.h>

Sprite_words::Sprite_words( Uint16 x, Uint16 y, char *file_sprite, TTF_Font *font, char **words ) :
Sprite( x, y, file_sprite )
{
    sprite_original = SDL_DisplayFormatAlpha( sprite );
    this->font = font;

    draw_words( words );
}

Sprite_words::~Sprite_words()
{
    SDL_FreeSurface( sprite_original );
}

void Sprite_words::setWords( char **words )
{
    draw_words( words );
}

void Sprite_words::draw_words( char **words )
{
    SDL_FreeSurface( sprite );
    sprite = SDL_DisplayFormatAlpha( sprite_original );

    for( int i=0 ; words[i]!=NULL ; i++ )
    {
        SDL_Color black  = {0,0,0,0};
        SDL_Surface *word_surface = TTF_RenderText_Blended( font, words[i], black );
        if( word_surface != NULL )
        {
            SDL_Rect rect = { 20+(int(i/5))*150, 30+(i%5)*32, word_surface->w, word_surface->h };
            SDL_BlitSurface( word_surface, NULL, sprite, &rect );
            SDL_FreeSurface( word_surface );
        }
    }

    state = state_null;
}
